<template>
  <div class="my-10">
    <h3>D3 Scatter Plot</h3>
    <svg id="chart" width="500" height="500"></svg>
  </div>
</template>

<script>
import * as d3 from "d3";

export default {
  name: "D3ScatterPlot",
  props: ["Sdata"]
  ,
  data() {
    return {
      dataPoints: [],
      maxPoints : 20
    };
  },
   mounted() {
    const width = 500;
    const height = 500;
    const margin = {
      top: 20,
      right: 20,
      bottom: 50,
      left: 60
    };

    this.chart = d3.select("#chart")
      .append("g")
      .attr("transform", `translate(${margin.left}, ${margin.top})`);
    this.x = d3.scaleLinear()
      .range([0, width - margin.left - margin.right]);

    this.y = d3.scaleLinear()
      .range([height - margin.top - margin.bottom, 0]);

    this.xAxis = this.chart.append("g")
      .attr(
        "transform",
        `translate(0, ${height - margin.top - margin.bottom})`
      );

    this.yAxis = this.chart.append("g");
    
    this.chart.append("text")
      .attr("font-size", 15)
      .attr("text-anchor", "middle")
      .attr("x", (width - margin.left - margin.right) / 2)
      .attr("y", height - margin.top - margin.bottom + 40)
      .text("x-axis");
    
    this.chart.append("text")
      .attr("font-size", 15)
      .attr("text-anchor", "middle")
      .attr("transform", "rotate(-90)")
      .attr("x", 0 - ((height - margin.top - margin.bottom) / 2))
      .attr("y", -40)
      .text("y-axis");

    this.plot();
  },
  created: function(){
    console.log(`Currently not showing more than ${this.maxPoints} (not needed in dev mode)`);
  } 
  ,
   methods: {
    plot() {
      this.x.domain([0, d3.max(this.dataPoints, d => d.x)]);
      this.y.domain([0, d3.max(this.dataPoints, d => d.y)]);

      this.xAxis.call(d3.axisBottom(this.x));
      this.yAxis.call(d3.axisLeft(this.y));
      var color = d3.scaleOrdinal()
      .domain([-1, 0, 1])
      .range([ "#F8766D", "#00BA38", "#619CFF"]) 
      this.chart.selectAll(".point")
        .data(this.dataPoints)
        .join("g")
        .attr("class", "point")
        .attr("transform", d => `translate(${this.x(d.x)}, ${this.y(d.y)})`)
        .append("circle")
        .attr("r", 8)
        .style('fill',function (d) { return color((d.x*d.x+d.y*d.y)%3) });
    },
    addPointToPlot(point) {


      if(this.dataPoints.length >= this.maxPoints){        
        return
      }

      this.dataPoints.push({
        x: point["x"],
        y: point["y"]
      });


      this.plot();
    }
  },
};
</script>

<style lang="sass" scoped>
svg
  margin: 25px
path
  fill: none
  stroke: #76BF8A
  stroke-width: 3px
</style>